﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Outlook = Microsoft.Office.Interop.Outlook

'Add-in Express Add-in Module
<GuidAttribute("326DDF18-3575-49C7-85BE-08501F0C4D23"), ProgIdAttribute("ADXSolutionsModuleVB.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule

#Region " Add-in Express automatic code "
 
    'Required by Add-in Express - do not modify
    'the methods within this region
 
    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub
 
    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub
 
#End Region
 
    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property

    Private Sub AddinModule_AddinStartupComplete(sender As System.Object, e As System.EventArgs) Handles MyBase.AddinStartupComplete
        ' Root Folder - Northwind
        Dim rootFolder As ADXOLSolutionFolder = New ADXOLSolutionFolder()
        rootFolder.FolderName = "Northwind"
        rootFolder.FolderType = ADXOLSolutionFolderType.Notes

        ' Child Folder - Sales
        Dim salesFolder As ADXOLSolutionFolder = New ADXOLSolutionFolder()
        salesFolder.FolderName = "Sales"
        salesFolder.FolderType = ADXOLSolutionFolderType.Notes

        ' Sales Folder - Child Folders
        Dim customersFolder As ADXOLSolutionFolder = New ADXOLSolutionFolder()
        customersFolder.FolderName = "Customers"
        customersFolder.FolderType = ADXOLSolutionFolderType.Notes

        ' Contacts Folder - Child Folders
        Dim contactsFolder As ADXOLSolutionFolder = New ADXOLSolutionFolder()
        contactsFolder.FolderName = "Contacts"
        contactsFolder.FolderType = ADXOLSolutionFolderType.Contacts

        ' Orders Folder - Child Folders
        Dim ordersFolder As ADXOLSolutionFolder = New ADXOLSolutionFolder()
        ordersFolder.FolderName = "Orders"
        ordersFolder.FolderType = ADXOLSolutionFolderType.Notes

        ' Add Sub-folders to Sales Folder
        salesFolder.Folders.Add(customersFolder)
        salesFolder.Folders.Add(contactsFolder)
        salesFolder.Folders.Add(ordersFolder)

        ' Add Sales folder to Root Folder
        rootFolder.Folders.Add(salesFolder)

        ' Add Root Folder to the Solution Module component
        AdxolSolutionModule1.Folders.Add(rootFolder)

        ' Get the default sore name
        Dim ns As Outlook.NameSpace = OutlookApp.GetNamespace("MAPI")
        Dim store As Outlook.Store = ns.DefaultStore
        Dim defaultStore As String = store.DisplayName
        Marshal.ReleaseComObject(store)
        Marshal.ReleaseComObject(ns)

        ' Add item to Forms Manager Collection
        Dim northwindFormItem As AddinExpress.OL.ADXOlFormsCollectionItem = New AddinExpress.OL.ADXOlFormsCollectionItem()
        northwindFormItem.FormClassName = "ADXSolutionsModuleVB.MyForm"
        northwindFormItem.FolderName = defaultStore + "\Northwind"
        AdxOlFormsManager1.Items.Add(northwindFormItem)
        northwindFormItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.WebViewPane

        Dim contactsFormItem As AddinExpress.OL.ADXOlFormsCollectionItem = New AddinExpress.OL.ADXOlFormsCollectionItem()
        contactsFormItem.FormClassName = "ADXSolutionsModuleVB.MyForm"
        contactsFormItem.FolderName = defaultStore + "\Northwind\Sales\Contacts"
        AdxOlFormsManager1.Items.Add(contactsFormItem)
        contactsFormItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.WebViewPane
    End Sub

    Private Sub AdxRibbonButton1_OnClick(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean) Handles AdxRibbonButton1.OnClick
        AdxOlFormsManager1.Items(0).FormClassName = "ADXSolutionsModuleVB.AnotherForm"
        Dim activeExplorer As Outlook._Explorer = OutlookApp.ActiveExplorer()
        AdxOlFormsManager1.Items(0).ApplyTo(activeExplorer)
        Marshal.ReleaseComObject(activeExplorer)
    End Sub
End Class

